; Modul LCD Anzeige
; Stellt Unterprogramme zur Verfgung fr die
; Anzeige der Uhrzeit, Alarmzeit und Steuerung der LCD-Anzeige
; -------------------------------------------------------------------

;
$NOMOD51							; 8051- Standard - Modus abschalten
$INCLUDE (REG515.inc)		; 80535- Registersatz bereitstellen

;--------------------------------------------------------------------
; Es wird anderen Modulen die Funktionen dieses Moduls bekannt gegeben

Public LCD_INIT, HOME,CLRSCR, Zeile1, Zeile2, Zeile2R, Zeile3, Zeile4
Public ENABLE, Zeichen, Z_STD,Z_MIN,Z_SEC
Public WARTEN,WARTEN2
Public AUSG


;--------------------------------------------------------------------
; Deklaration der Variablen


AUSG	equ P5	;Der Port 5 heit jetzt AUSG

;--------------------------------------------------------------------
LCD SEGMENT CODE			
	 RSEG	LCD
	 
ORG 400h
; LCD_INIT Initialisiert das LCD Display HD44780
; und Schaltet es ein
; Es wird der 4 Bit Modus verwendet d.h es wird ein Port verwendet
	
LCD_INIT:	mov	R0,#160		; Nach dem Einschalten erst mal 15ms warten 
				call  WARTEN		; Zeitschleife Aufrufen
				mov   AUSG,#03h	        ; Sende High-byte Function Set 8 Bit
				call	ENABLE
				mov	R0,#60
				call  WARTEN		; Zeitschleife Aufrufen
				mov   AUSG,#03h	       ; Sende High-byte Function Set 8 Bit
				call	ENABLE
				nop					; Warte 100s
				nop
				mov   AUSG,#03h	        ; Sende High-byte Function Set 8 Bit
				call	ENABLE
				
				mov   AUSG,#02h	        ; Sende High-byte Function Set 4 Bit (0010)
				call	ENABLE
				
				mov   AUSG,#02h 	; Sende High-byte Function Set 4 Bit (0010)
				call	ENABLE
				mov	AUSG,#08h	; Sende Low -byte 2 Zeilen, 2 zeilen Font 5x8 Dots (1000) 
				call	ENABLE
		
										
				mov	AUSG,#00h	; Display Lschen
				call	ENABLE
				mov	AUSG,#01h
				call	ENABLE
				mov	R0,#60
				call  WARTEN		; Kurz Warten
				 						
				mov	AUSG,#00h	; Display ein
				call	ENABLE
				mov	AUSG,#0Ch
				call	ENABLE 
				 
				         		
				mov	AUSG,#00h	; Entry mode set
				call 	ENABLE
				mov	AUSG,#06h
				CALL	ENABLE
				ret			; Ende der Initialisierungsroutine 
;-------------------------------------------------------------------------------------------
; Flexibele Verzgerungsroutine 
; R0 enthlt den bergebenen verzgerungswert
WARTEN:		PUSH	PSW			; PSW retten	
				PUSH	00h			; R0 retten
	
LOOP2:		                mov	R2,#250		        ; lade 250 in R2
LOOP3:		                djnz	R2,LOOP3		; Dauert 2 M-zyklen entspr. (2 * 250 Durchlufe)
				djnz	R0,LOOP2		; 
				POP	00h			; R0 wieder herstellen
				POP	PSW			; PSW wieder herstellen
				ret				; zurck
;-------------------------------------------------------------------------------------------
; Flexibele Verzgerungsroutine 
; R0 enthlt den bergebenen verzgerungswert
WARTEN2:		PUSH	PSW			; PSW retten	
				PUSH	00h		; R0 retten
				mov	R0,#5	
LP1:			mov	R1,#255
LP2:			mov	R2,#255		        ; lade 250 in R2
LP3:			djnz	R2,LP3		        ; Dauert 2 M-zyklen entspr. (2 * 250 Durchlufe)
				djnz	R1,LP2		
				djnz	R0,LP1	        ; 
				POP	00h	        ; R0 wieder herstellen
				POP	PSW	        ; PSW wieder herstellen
				ret			; zurck


;-------------------------------------------------------------------------------------------
; Enable wird verwendet um einen Befehl oder Zeichen an den HD44780 zu bertragen
; bertragen wird mit Fallender Flanke

ENABLE:				PUSH	PSW		; PSW retten	
				PUSH 	00h		; Registerbnke retten
				PUSH    08h        
                            	PUSH	18h			
				
				orl	AUSG,#10h	; Setze Enable P5.4 Signal
				mov	R0,#30		; Lade verzgerungswert in R0
VERZ2:				djnz	R0,VERZ2	; Bentigt 60 M-Zyklen
				anl	AUSG,#0EFh	; Setze Enable zurck Daten mssen noch kurz anstehen
				NOP
				mov	AUSG,#00h	; P5 auf zurcksetzen
				
				POP	18h		; Registerbnke wieder herstellen
				POP	08h
				POP	00h
				POP	PSW		; PSW wieder herstellen
				ret			; zurck
				
HOME:							; Cursor Home
				mov	AUSG,#00h     ;erst Highbyte senden
				call	ENABLE
				mov	AUSG,#02h     ;dann Lowbyte senden
				call	ENABLE
				mov	R0,#60
				call  WARTEN		; Zeitschleife Aufrufen				
				ret
ClRSCR:							  ; Display lschen
				mov	AUSG,#00h	;erst Highbyte senden
				call	ENABLE
				mov	AUSG,#01h   ;dann Lowbyte senden
				call	ENABLE
				mov	R0,#60
				call  WARTEN		; Kurz Warten	
				ret
Zeile1:
				mov	AUSG,#08h	; Cursor auf Zeile 1 schalten, erst Highbyte senden
				call	ENABLE
				mov	AUSG,#00h   ;dann Lowbyte senden
				call	ENABLE
				ret


Zeile2:
				mov	AUSG,#0Ch	; Cursor auf Zeile 2 schalten, erst Highbyte senden
				call	ENABLE
				mov	AUSG,#00h   ;dann Lowbyte senden
				call	ENABLE
				ret
Zeile3:
				mov	AUSG,#09h
				call	ENABLE
				mov	AUSG,#04h
				call	ENABLE
				ret


Zeile4:
				mov	AUSG,#0Dh
				call	ENABLE
				mov	AUSG,#04h
				call	ENABLE
				ret
				
Zeile2R:
				mov	AUSG,#0Ch
				call	ENABLE
				mov	AUSG,#09h
				call	ENABLE
				ret
Z_STD:
				mov	AUSG,#0Ch
				call	ENABLE
				mov	AUSG,#09h
				call	ENABLE
				ret
Z_MIN:
				mov	AUSG,#0Ch
				call	ENABLE
				mov	AUSG,#0Ch
				call	ENABLE
				ret
Z_SEC:
				mov	AUSG,#0Ch
				call	ENABLE
				mov	AUSG,#0Fh
				call	ENABLE
				ret

Zeichen:		mov	R7,A         ;Ausgabe eines Zeichen bergaberegister ist Akku 
				swap	A				 ;Nibbles tauschen
				anl	A,#0Fh       ;erst Highbyte senden
				mov	AUSG,a
				orl	AUSG,#40h	 ;RS setzen fr Daten
				call	ENABLE       ;Jetzt zum Display bertragen mit fallender Flanke
				mov	a,R7         ;Zeichen wieder in den Akku Laden
				anl	a,#0Fh       ;jetzt Lowbyte senden
				mov	AUSG,a
				orl	AUSG,#40h    ;RS setzen fr Daten
				call	ENABLE       ;Jetzt zum Display bertragen mit fallender Flanke
            RET
end			;Modul ende							



